Subject: Re: Download Incomplete. Try again?
From: Luke Kendall <[email-masked]>
To: [email-masked]
Cc: Igor Pechtchanski <[email-masked]>
Date: Tue, 26 Jul 2005 13:14:21 +1000 (EST)

On 25 Jul, Igor Pechtchanski replied to:

> > Is there a way to test if a downloaded cygwin will cause the "Download
> > Incomplete.  Try again?" error, except by running setup.exe?
>  
>  Yes, there is.  There is no magic in setup.exe (well, not much, in any
>  case).  Check the filenames, file sizes and md5sums against setup.ini, not
>  the md5.sum files.

Really?!  I modified my md5cychk script to perform that check.  Our
old, stable, working Cygwin mirror installs and runs fine, and all the
md5.sum files check correctly against the package files.  But 53 of the
package files differ in their version against the setup.ini file.

Ah, wait!  Should I only check md5s if a package filename (and hence
version) in setup.ini matches against a file in the package directory?

Does setup.exe only complain if setup.ini files are a *subset* of the
files in the package directory?  At the moment I'm checking for perfect
congruence.

E.g.:

Pkg X-startup-scripts: checksum mismatch vs setup.ini
Pkg fontconfig: checksum mismatch vs setup.ini
Pkg libfontconfig-devel: checksum mismatch vs setup.ini
Pkg libfontconfig1: checksum mismatch vs setup.ini
Pkg gd: checksum mismatch vs setup.ini
Pkg xterm: checksum mismatch vs setup.ini
Pkg a2ps: checksum mismatch vs setup.ini
Pkg automake-devel: checksum mismatch vs setup.ini
Pkg bzip2: checksum mismatch vs setup.ini
[...]
In /u/install/win32/cygwin/release/./X11/X-startup-scripts:
Pkg X-startup-scripts: checksum mismatch vs setup.ini
diff of setup.ini's data vs X-startup-scripts's:
0a1,4
> 3e5ba8a0c74efc0784cfb281c8bc7b8d  X-startup-scripts-1.0.4-1-src.tar.bz2
> ac7df29735b5cd2a005bfae7a22f067a  X-startup-scripts-1.0.4-1.tar.bz2
> 73274cafa8be97c22819b774e8ec1ff8  X-startup-scripts-1.0.5-1-src.tar.bz2
> e9e13454d75bab7214524556abd3493a  X-startup-scripts-1.0.5-1.tar.bz2
---
==> /tmp/md5cyg16373.md5.top <==
7f0d9fffe50e455017027a005face0af X-startup-scripts-1.0.6-1-src.tar.bz2
dd904397cac9f70fc4d8c1d4e3ccb1b3 X-startup-scripts-1.0.6-1.tar.bz2
d622b56c7d1c7898bc4a298945f748f6 X-startup-scripts-1.0.7-1-src.tar.bz2
0168dd4200f2d9fdf5a5589873c31f1f X-startup-scripts-1.0.7-1.tar.bz2

> > By looking through the mailing list archives, I got the impression that
> > this happened when the setup.ini file got out of sync with the
> > collection of packages - but Christopher explained that setup.ini only
> > gets updated occasionally.
>  
>  Exactly.
>  
> > And I can confirm that: many of the package versions in setup.ini don't
> > match the versions of the packages present, even in stable and
> > installable cygwin mirrors.
>  >
> > Is that because setup.ini gets updated manually?
>  
>  Probably yes.  If the mirroring process catches the main Cygwin repository
>  in a state where a package is uploaded, but setup.ini hasn't been updated,
>  the repository will be in an inconsistent state.

Can setup.ini be out of date for long periods, because it is updated
manually? 

> > Would you like me to try to design an easy system to regenerate it
> > automatically when packages are updated?  (I'm imagining a tree of
> > per-package description parts which change infrequently, and a script
> > which adds the file size and md5 sig automatically.  Perhaps it should
> > even be a Makefile.)
>  
>  Eh?  There's more to it than that -- setup.ini also has versions, etc.

Oh!  But when we mirror a site, we only see a single setup.ini file.

> > [snip email about setup.ini size/md5sum mismatch (with raw e-mail
> > addresses, I might add)]

[Oh: the cygwin-xfree address itself?  Sorry. :-(  ]

> > But is that the cause of the problem?
>  
>  Yes.
>  
> > If not, does anyone know what the real problem is?
>  >
> > If the only way is by running setup.exe, is that unlikely to damage an
> > older, working Cygwin install?
>  
>  If you run setup in download mode, you will not affect the existing
>  install.
>  HTH,
>  	Igor

I think it does: the download would fail with the above error message,
so you would know not to proceed?

I think I'm starting to understand.  (With some gaps, though.)

luke

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/